/*
 * Copyright 2011 Leiden University. All rights reserved.
 */

#include <assert.h>
#include "adg_cmp_options.h"
#include "adg_parse.h"

int main(int argc, char *argv[])
{
	isl_ctx *ctx;
	struct options *options;
	FILE *file1, *file2;
	adg *adg1, *adg2;
	int equal;

	options = options_new_with_defaults();
	assert(options);
	argc = options_parse(options, argc, argv, ISL_ARG_ALL);
	ctx = isl_ctx_alloc_with_options(&options_args, options);

	file1 = fopen(options->adg1, "r");
	assert(file1);
	file2 = fopen(options->adg2, "r");
	assert(file2);

	adg1 = adg_parse(ctx, file1);
	assert(adg1);
	adg2 = adg_parse(ctx, file2);
	assert(adg2);

	equal = adg1->is_equal(adg2);

	delete adg2;
	delete adg1;

	fclose(file2);
	fclose(file1);
	isl_ctx_free(ctx);

	return equal ? 0 : 1;
}
