#include <iostream>

#include <isa/yaml.h>
#include <isa/pdg.h>

using namespace std;
using namespace pdg;

int main(int argc, char * argv[])
{
    PDG *pdg;
    isl_ctx *ctx = isl_ctx_alloc();
    pdg = PDG::Load(stdin, ctx);
    int channels = 0;
    int wires = 0;
    int non_wires = 0;
    int selfloops = 0;
    int registers = 0;
    int connections = 0;
    int reorderings = 0;
    int fifos = 0;
    int union_fifos = 0;
    int single_fifos = 0;
    int channel[2][2][2];

    for (int i = 0; i < 2; ++i)
	for (int j = 0; j < 2; ++j)
	    for (int k = 0; k < 2; ++k)
		channel[i][j][k] = 0;

    for (int i = 0; i < pdg->dependences.size(); ++i) {
	pdg::dependence *dep = pdg->dependences[i];
	if (dep->type == pdg::dependence::uninitialized)
	    continue;
	channels++;
	if (dep->type == pdg::dependence::pn_part) {
	    wires++;
	    continue;
	}
	if (dep->type == pdg::dependence::pn_wire) {
	    wires++;
	    continue;
	}
	non_wires++;
	channel[dep->reordering][dep->multiplicity][dep->from != dep->to]++;
	if (dep->from == dep->to && dep->size && !strcmp(dep->size->s->c_str(), "1"))
	    registers++;
    }
    printf("%d = %d + (%d = ((%d + %d) + %d) + (%d + %d) + (%d + %d) + (%d + %d))\n",
	    channels, wires, non_wires,
	    registers, channel[0][0][0]-registers, channel[0][0][1],
	    channel[0][1][0], channel[0][1][1],
	    channel[1][0][0], channel[1][0][1],
	    channel[1][1][0], channel[1][1][1]);

    pdg->free();
    delete pdg;
    isl_ctx_free(ctx);

    return 0;
}
