#include <stdio.h>
#include <cloog/cloog.h>

struct clast_scanner {
    FILE    *dst;
    int	indent;

    void print_indent() {
	fprintf(dst, "%*s", indent, "");
    }
    clast_scanner() : indent(0), dst(NULL) {}

    void print(clast_name *e);
    void print(clast_term *e);
    void print(clast_reduction *e);
    void print(clast_binary *e);
    void print(clast_expr *e);
    void print(clast_stmt *s);
    void print(clast_assignment *s);
    virtual void print_user(clast_user_stmt *s) = 0;
    void print(clast_for *s);
    void print(clast_guard *s);

    void print_header();
    void print_iterators(CloogNames* names);
};
