#ifndef CLOOG_UTIL_H
#define CLOOG_UTIL_H

#include <cloog/cloog.h>
#include <isa/pdg.h>

/* Replace compound conditionals by cascading conditionals.
 * I.e., 
 *	    if (a && b)
 * =>
 *	    if (a)
 *		if(b)
 *
 * Also replace compound upper bounds by a simple upper bound
 * and a set of conditionals.
 */
void cloog_util_simple_guards(clast_stmt *s);

/* Hoist ifs that are common to several adjacent statements.
 *
 * The code assumes that cloog_util_simple_guards has been called first.
 */
clast_stmt *cloog_util_hoist_ifs(clast_stmt *s);

#endif
