#include <stdio.h>
#include "da_options.h"
#include "version.h"

static void print_version(void)
{
	printf("%s\n", pdg_version());
}

static struct isl_arg_flags type[] = {
	{"flow",	TYPE_FLOW,		TYPE_FLOW},
	{"anti",	TYPE_ANTI,		TYPE_ANTI},
	{"output",	TYPE_OUTPUT,		TYPE_OUTPUT},
	{"reuse_pair",	TYPE_REUSE_PAIR,	TYPE_REUSE_PAIR},
	{0}
};

ISL_ARGS_START(struct options, options_args)
ISL_ARG_CHILD(struct options, isl, "isl", &isl_options_args, "isl options")
ISL_ARG_STR(struct options, input, 'i', "input", "filename", NULL, NULL)
ISL_ARG_STR(struct options, output, 'o', "output", "filename", NULL, NULL)
ISL_ARG_FLAGS(struct options, types, 't',
	"type", type, TYPE_FLOW | TYPE_ANTI, NULL)
ISL_ARG_BOOL(struct options, array_types, 'A', "array-types", 0,
	"compute array types")
ISL_ARG_BOOL(struct options, verbose, 0, "verbose", 0, NULL)
ISL_ARG_VERSION(&print_version)
ISL_ARGS_END

ISL_ARG_DEF(options, struct options, options_args)
