#ifndef DUMP_H
#define DUMP_H

#include <vector>

#include "domain.h"

class dumper {
    context_info	   *ctx;
    tree_proc		   *tp;
    symtab_ann 		   *sa;
    int			    root;
    map<var_sym*, pdg::array*>    arrays;
    pdg::PDG *pdg;
    isl_space		    *dim;	/* parameters */
    int totalread;
    int nread;
    int nwrite;
public:
    std::vector<domain_ann *>	    nodes;
    void scan();
    void dump(int argc, char * argv[]);
    void visit(tree_node *t);
    dumper(tree_proc *t, context_info *ctx) : tp(t), ctx(ctx) {
	sa = (symtab_ann *)tp->peek_annote(k_domain_symtab);
    }
    ~dumper();

    pdg::access *add_access(pdg::node *pn, stmt_access *sa);
    pdg::call_or_access *scan_stmt(pdg::node *pn, stmt_node *n);
    pdg::function_call *scan_stmt(pdg::node *pn, stmt *s);
};

void dump(tree_proc * tp, context_info *ctx, int argc, char * argv[]);

#endif
