#include <isl/map.h>

#include <isa/yaml.h>
#include <isa/pdg.h>

using namespace pdg;

int main(int argc, char * argv[])
{
    PDG *pdg;
    isl_ctx *ctx = isl_ctx_alloc();
    pdg = PDG::Load(stdin, ctx);

    for (int i = 0; i < pdg->nodes.size(); ++i) {
	pdg::node *node = pdg->nodes[i];
	isl_map *map = node->schedule->get_isl_map(ctx);
	printf("node %d: ", node->nr);
	isl_map_print(map, stdout, 0, ISL_FORMAT_ISL);
	printf("\n");
	isl_map_free(map);
    }

    pdg->free();
    delete pdg;
    isl_ctx_free(ctx);

    return 0;
}
