#include <iostream>

#include <isa/yaml.h>
#include <isa/pdg.h>

using namespace std;
using namespace pdg;

int main(int argc, char * argv[])
{
    PDG *pdg;
    isl_ctx *ctx = isl_ctx_alloc();
    pdg = PDG::Load(stdin, ctx);

    for (int i = 0; i < pdg->dependences.size(); ++i) {
	pdg::dependence *dep = pdg->dependences[i];
	if (dep->type == pdg::dependence::uninitialized)
	    continue;
	pdg::node* from = dep->from;
	pdg::node* to = dep->to;
	int from_access = dep->from_access ? dep->from_access->nr : -1;
	int to_access = dep->to_access ? dep->to_access->nr : -1;
	const char *from_f = from->statement->top_function ?
			     from->statement->top_function->name->s.c_str() :
			     "(none)";
	const char *to_f = to->statement->top_function ?
			   to->statement->top_function->name->s.c_str() : "(none)";
	printf("%d,%d (%s,line %d) --(%s)--> %d,%d (%s,line %d): %s\n",
		from->nr, from_access, from_f, from->statement->line,
		dep->array->name->s.c_str(),
		to->nr, to_access, to_f, to->statement->line,
		dep->size ? dep->size->s->c_str() : "(unknown)"
		);
    }

    pdg->free();
    delete pdg;
    isl_ctx_free(ctx);

    return 0;
}
