#include <vector>

#include "dependence_graph.h"

typedef std::pair<computation *, computation *> computation_pair;
typedef std::pair<int, int> state_pair;
typedef std::pair<state_pair,int> transition_t;

struct MSA {
	std::vector<isl_map *>		firing;
	std::vector<computation_pair>	state;
	std::vector<transition_t>	transition;
	/* Fail states */
	std::vector<int>		fail_state;
	/* States that correspond to identical input computations */
	std::vector<int>		input_state;
	/* States that correspond to invocations of the same constant function */
	std::vector<int>		cst_state;

	int add(computation *c1, computation *c2);
	int add_firing(int source, int target, __isl_take isl_map *map);

	~MSA() {
		for (int f = 0; f < firing.size(); ++f)
			isl_map_free(firing[f]);
	}
};
