#include <isl/polynomial.h>
#include "size.h"
#include "size_bernstein.h"

namespace size {

size::enumerator *selfloop_size_bernstein(pdg::PDG *pdg,
	__isl_take isl_map *dep, __isl_take isl_set *read)
{
	isl_pw_qpolynomial *pwqp;
	isl_pw_qpolynomial_fold *ub;

	pwqp = selfloop_tokens_in_fifo(dep, read);

	ub = isl_pw_qpolynomial_bound(pwqp, isl_fold_max, NULL);
	ub = isl_pw_qpolynomial_fold_coalesce(ub);

	ub = isl_pw_qpolynomial_fold_gist(ub, pdg->get_context_isl_set());

	return new size::enumerator(ub, pdg);
}

}
