#ifndef SREL_H
#define SREL_H

#include "suif_inc.h"
#include <omega.h>
#include <vector>
#include <isa/pdg.h>

using namespace omega;

class symtab_ann;
class stmt_node;

class SRelation : public Relation {
public:
    symtab_ann	    *sa;
    F_Exists	    *e;
    F_And	    *f;
    std::vector<stmt_node *> nested;

    SRelation(symtab_ann *a) : Relation(0), sa(a) {
	e = add_exists();
	f = e->add_and();
    }
    SRelation(symtab_ann *a, named_lin_ineq *nlq) : Relation(0, 0), sa(a) {
	e = add_exists();
	f = e->add_and();
	intersect(nlq);
    }
    SRelation(SRelation &s) : Relation(s), sa(s.sa), nested(s.nested) {}
    SRelation (Relation & r, symtab_ann *a) : Relation(r), sa(a) {}
    SRelation(Relation &r, symtab_ann *a, std::vector<stmt_node *> nested)
	: Relation(r), sa(a), nested(nested) {}
    SRelation (int in, int out, std::vector< std::vector<int> > & c, 
	       symtab_ann *a);
    void fix(var_sym *var, int val);
    void set_infinite(var_sym *var);
    void intersect(named_lin_ineq *nlq);
    SRelation *Intersection(SRelation *b);
    SRelation *Union(SRelation *b);
    SRelation *Difference(SRelation *b);
    SRelation *Composition(SRelation *b);
    SRelation *Complement();
};

#endif
