#include <assert.h>
#include "testlib.h"

using pdg::PDG;

int main(int argc, char *argv[])
{
    isl_ctx *ctx = isl_ctx_alloc();
    PDG *pdg = get_pdg(ctx, "testarg");

    assert(pdg->nodes.size() == 2);
    assert(pdg->nodes[0]->statement->accesses.size() == 2);
    assert(pdg->nodes[0]->statement->accesses[0]->type == pdg::access::read);
    assert(pdg->nodes[0]->statement->accesses[1]->type == pdg::access::write);
    assert(pdg->nodes[1]->statement->accesses.size() == 2);
    assert(pdg->nodes[1]->statement->accesses[0]->type == pdg::access::read);
    assert(pdg->nodes[1]->statement->accesses[1]->type == pdg::access::write);

    pdg->free();
    delete pdg;
    isl_ctx_free(ctx);

    return 0;
}
