#include <assert.h>
#include "testlib.h"

using pdg::PDG;

static void check(isl_ctx *ctx, const char *base, const char *options,
		  int nodes, int deps, int regs)
{
    construct_pdg(base);
    PDG *pdg = get_pn(ctx, base, options);

    assert(pdg->nodes.size() == nodes);
    assert(pdg->dependences.size() == deps);
    int registers = 0;
    for (int i = 0; i < pdg->dependences.size(); ++i) {
	pdg::dependence *dep = pdg->dependences[i];
	assert(!dep->reordering);
	assert(!dep->multiplicity);
	if (dep->value_size && dep->value_size->v == 1)
	    ++registers;
    }
    assert(registers == regs);

    pdg->free();
    delete pdg;
}

int main(int argc, char *argv[])
{
    isl_ctx *ctx = isl_ctx_alloc();
    check(ctx, "testblocking", NULL, 3, 3, 3);
    check(ctx, "testblocking", "--move", 3, 3, 2);
    check(ctx, "testblocking2", NULL, 4, 5, 5);
    check(ctx, "testblocking2", "--move", 4, 5, 5);
    isl_ctx_free(ctx);
    return 0;
}
