#define TARGETS 3

void getLSODTarget(int t, int *Height, int *Width,
	int *offset_x, int *offset_y);
int readTarget(int k, int w, int h, int x, int y);
int gradient(int a1, int a2, int a3, int a4, int a5, int a6);
int absVal(int x);
int vertSum(int in_1, int in_2);
void writeHist(int k, int w, int pp);
int init(void);

int main(void)
{
   int i, j, k;
   int offset_x,offset_y;

   static int image[1000][1000];
   static int vertEdges[1000][1000];
   static int av[1000][1000];
   static int vsum[1000];
   static int TH[TARGETS];
   static int TW[TARGETS];
   #pragma value_bounds TH 10 300
   #pragma value_bounds TW 10 350

   
   for (k = 0; k < TARGETS; k++) {
      getLSODTarget(k, &TH[k], &TW[k], &offset_x, &offset_y);
   
      for (j = 0; j < TH[k]; j++)
	  for (i = 0; i < TW[k]; i++)
	    image[j][i] = readTarget(k, i, j, offset_x, offset_y);   

      for (i = 0; i < TW[k]; i++)
          vsum[i] = init();  

      for (j = 1; j < TH[k] - 1; j++) {
	  for (i = 1; i < TW[k] - 1; i++) {
	      vertEdges[j][i] = gradient(image[j-1][i-1], image[j][i-1],
					image[j+1][i-1], image[j-1][i+1],
					image[j][i+1], image[j+1][i+1]);
	      av[j][i] = absVal(vertEdges[j][i]);
	      vsum[i] = vertSum(vsum[i], av[j][i]);
	  }
      }

      for (i = 1; i < TW[k] - 1; i++)
 	  writeHist(k, TW[k], vsum[i]);
   }

   return 0;
}

