#include <assert.h>
#include "testlib.h"

using pdg::PDG;

int main(int argc, char *argv[])
{
    isl_ctx *ctx = isl_ctx_alloc();
    construct_pdg("QR");
    PDG *pdg = get_pn(ctx, "QR");

    assert(pdg->nodes.size() == 5);
    assert(pdg->dependences.size() == 12);
    for (int i = 0; i < pdg->dependences.size(); ++i) {
	pdg::dependence *dep = pdg->dependences[i];
	assert(!dep->reordering);
	assert(!dep->multiplicity);
    }

    pdg->free();
    delete pdg;

    construct_pdg("sobel");
    pdg = get_pn(ctx, "sobel");

    int n_shift = 0;
    assert(pdg->dependences.size() == 5);
    for (int i = 0; i < pdg->dependences.size(); ++i) {
	pdg::dependence *dep = pdg->dependences[i];
	assert(dep->value_size->v > 0);
	if (pdg->dependences[i]->type == pdg::dependence::pn_shift)
		n_shift++;
    }
    assert(n_shift == 2);

    pdg->free();
    delete pdg;

    construct_pdg("arg_order");
    pdg = get_pn(ctx, "arg_order");

    assert(pdg->dependences.size() == 1);
    assert(pdg->dependences[0]->to != pdg->dependences[0]->from);

    pdg->free();
    delete pdg;
    isl_ctx_free(ctx);

    return 0;
}
