#include <assert.h>
#include "testlib.h"

using pdg::PDG;

int main(int argc, char *argv[])
{
    isl_ctx *ctx = isl_ctx_alloc();
    PDG *pdg = get_pdg(ctx, "testscalar");
    int n_access = 0;
    pdg::access *access = NULL;

    assert(pdg->nodes.size() == 1);
    for (int i = 0; i < pdg->nodes[0]->statement->accesses.size(); ++i) {
	if (!pdg->nodes[0]->statement->accesses[i]->array)
	    continue;
	n_access++;
	access = pdg->nodes[0]->statement->accesses[i];
    }
    assert(n_access == 1);
    assert(access->type == pdg::access::write);
    assert(access->map->input() == 0);
    assert(access->map->output() == 0);

    pdg->free();
    delete pdg;
    isl_ctx_free(ctx);

    return 0;
}
