#include <assert.h>
#include "testlib.h"

using pdg::PDG;

int main(int argc, char *argv[])
{
	isl_ctx *ctx = isl_ctx_alloc();
	construct_pdg("testshift");
	PDG *pdg = get_pn(ctx, "testshift");

	assert(pdg->dependences.size() == 3);
	int n_shift = 0;
	for (int i = 0; i < pdg->dependences.size(); ++i) {
		if (pdg->dependences[i]->type == pdg::dependence::pn_shift)
			n_shift++;
	}
	assert(n_shift == 1);

	pdg->free();
	delete pdg;
	isl_ctx_free(ctx);

	return 0;
}
